using System;
//using System.Collections;
//using System.ComponentModel;
//using System.Drawing;
using System.Windows.Forms;

namespace Westwind.Windows
{
	/// <summary>
	/// Data aware checkbox
	/// </summary>
	public class wwCheckBox : System.Windows.Forms.CheckBox, IwwDataControl
	{
		
		/// <summary>
		/// The object that the control is bound to. This is the base object
		/// and you are still required to set the ControlSource property with
		/// the property to bind to
		/// </summary>
		public string ControlSourceObject
		{ 
			get 
			{ 	return this.cControlSourceObject;	}
			set
			{	this.cControlSourceObject = value;	}
		}
		string  cControlSourceObject = null;

		/// <summary>
		/// The ControlSource property to bind to set as a string. Uses Reflection to retrieve and set 
		/// content of the object in question
		/// </summary>
		public string ControlSourceProperty 
		{
			get { return this.cControlSourceProperty; }
			set { this.cControlSourceProperty = value; }
		}
		string cControlSourceProperty = "";


		/// <summary>
		/// Field or type that this control is bound to
		/// </summary>
		public string BindingProperty
		{
			get { return this.cBindingProperty; }
			set { this.cBindingProperty = value; }
		}
		string cBindingProperty = "Checked";



//		protected override void OnPaint(PaintEventArgs pe)
//		{
//			// TODO: Add custom paint code here
//
//			// Calling the base class OnPaint
//			base.OnPaint(pe);
//		}

		/// <summary>
		/// Custom Databinding that binds the data back into the control.
		/// </summary>
		public void BindData(object loParent) 
		{
			wwDataControlHelper.ControlBindData(this,loParent,this.cControlSourceObject,
				this.cControlSourceProperty, this.cBindingProperty);
		}

	}
}
