*** Set this switch to switch between passing
*** Fox or COM objects to .NET COM
#DEFINE USE_COM_CUSTOMER .T.
#DEFINE MODALWINFORM  .T.

PUBLIC loNet, loNetForm
#IF .F.
LOCAL loNet as DotNetCom.DotNetComPublisher
#ENDIF
loNet = CREATEOBJECT('DotNetCom.DotNetComPublisher') 

*** Create a Customer Object Instance (factory method)
loCustomer = GetCustomer()

loCustomer.Name = "Rick Strahl"
loCustomer.Company = "West Wind Technologies"
loCustomer.creditLimit = 9999999999.99

loCustomer.oAddress.StreetAddress = "32 Kaiea Place"
loCustomer.oAddress.Phone = "808 579-8342"
loCustomer.oAddress.Email = "rickstrahl@hotmail.com"

PUBLIC loNetForm
#IF .F.
LOCAL loNetForm as DotNetCOM.WinFormCom, loNetForm as DotNetCOM.WinFormCom
#ENDIF

*** Modal Fox Object
#IF ModalWinForm
   loNetForm = CREATEOBJECT("DotNetCom.WinformCom")
#ELSE
   loFactory = CREATEOBJECT("DotNetCom.WinFormComFactory")
   loNetForm = loFactory.RunForm()
#ENDIF

*** Pass the actual object to .NET COM
#IF USE_COM_CUSTOMER
	loNetForm.LoadCustomer(loCustomer)
#ELSE
	loNetForm.LoadFoxCustomer(loCustomer)
#ENDIF

loNetForm.Show()


RETURN



*** Non-Modal COM Object with Databinding

*** Create a Factory instance of a multithreaded COM object
loForm = CREATEOBJECT("DotNetCom.WinFormCom")
loNetForm = loForm.RunForm()
loNetForm.LoadCustomer(loCustomer)  

RETURN


FUNCTION GetCustomer
LOCAL loCustomer, loAddress

#IF !USE_COM_CUSTOMER
   loCustomer = CREATEOBJECT("EMPTY")
   ADDPROPERTY(loCustomer,"Name","")
   ADDPROPERTY(loCustomer,"Company","")
   ADDPROPERTY(loCUstomer,"CreditLimit",0.00)
   ADDPROPERTY(loCustomer,"Entered",DATETIME())

   loAddress = CREATEOBJECT("Empty")
   ADDPROPERTY(loAddress,"StreetAddress","")
   ADDPROPERTY(loAddress,"Phone","")
   ADDPROPERTY(loAddress,"Email","")

   ADDPROPERTY(loCustomer,"oAddress",loAddress)
#ELSE
   *** Load the customer as a COM object!
   LOCAL loCustomer as DOTNETCOM.Customer
   loCustomer = CREATEOBJECT("DotNetCom.Customer")
#ENDIF

RETURN loCustomer
ENDFUNC

FUNCTION ForceFoxFocus()
*** Fix Focus Problem
*** Force Fox app to activate
DECLARE integer SendMessage IN WIN32API ;
        integer hWnd,integer Msg,;
        integer wParam,;
        Integer lParam
SendMessage(_SCREEN.HWnd,0x06,1,0)
ENDFUNC