LPARAMETERS lcUrl, lcFile

#DEFINE MultiThreadedEventDownload .T.

IF EMPTY(lcUrl)
   lcUrl = "http://www.west-wind.com/files/wwClient.zip"
ENDIF
IF EMPTY(lcFile)
   lcFile = "wwclient.zip"
ENDIF   

PUBLIC poDownload

poDownload = NEWOBJECT("wwHttpDownloadDialog","wwHttpDownloadDialog.vcx")
poDownload.Width = 340
poDownload.cOutputFileName = "wwClient.zip"
poDownload.nDownloadBufferSize = 8196

poDownload.StartDownload(lcUrl,;
 "Downloading file from West Wind Technologies site")

*** Hook up download notification event
PUBLIC poNotification
poNotification = CREATEOBJECT("DownloadNotification")

BINDEVENT(poDownload,"OnDownloadComplete",;
          poNotification,"OnDownloadComplete")

RETURN

DEFINE CLASS DownloadNotification as Custom

FUNCTION OnDownloadComplete
   poDownload.visible = .f.
   RELEASE poDownload
   DOEVENTS
   MESSAGEBOX("Hey wake up: Download is complete.")
ENDFUNC

ENDDEFINE

*** Event Implementation

DEFINE CLASS IwwHttpEvents AS session OLEPUBLIC
  IMPLEMENTS IwwHttpEvents IN "DotNetCom.wwHttp"

PROCEDURE IwwHttpEvents_ReceiveData(;
         sender AS VARIANT, e AS Variant) AS VOID
ENDPROC

PROCEDURE IwwHttpEvents_SendData(;
  sender AS VARIANT, e AS VARIANT) AS VOID
ENDPROC

ENDDEFINE


*** .NET WinForm Download events
DEFINE CLASS IDownloadFormEvents AS session OLEPUBLIC
   IMPLEMENTS IDownloadFormEvents IN "DotNetCom.wwHttp"

   PROCEDURE IDownloadFormEvents_DownloadComplete() AS VOID
   * add user code here
   ENDPROC

   PROCEDURE IDownloadFormEvents_DownloadCancelled() AS VOID
   * add user code here
   ENDPROC
ENDDEFINE
